#include <Arduino.h>
#include <U8g2lib.h>
#ifdef U8X8_HAVE_HW_SPI
#include <SPI.h>
#endif
#ifdef U8X8_HAVE_HW_I2C
#include <Wire.h>
#endif
const int Button1 = 13; //Button on joystick. Returns LOW when pressed returns HIGH when not pressed.//
int ButtonState = 1;
const int AxisY = 0; //Pin of X Axis for joystick// 
const int AxisX = 1; //Pin of Y Axis for joystick//
int AxisYv = 0; //Y Axis of joystick//
int AxisXv = 0; //X Axis of joystick//
int LineNum = 12; //Starting selector Line Number//
int LineVal = 0; //0-4 Value of selected line//
int PageVal = 0; //What page is selected//
boolean CF = 0; //Celcius or Farenheit

U8G2_ST7920_128X64_F_SW_SPI u8g2(U8G2_R0, /* clock=*/ 18, /* data=*/ 16, /* CS=*/ 17, /* reset=*/ 8);


void setup() {
  u8g2.begin(); //initialize u8g2//
  u8g2.clearBuffer(); //clear the screen buffer//
  pinMode(Button1, INPUT); //set pinmode of joystick button//
  Serial.begin(9600);
  LCD1(); //start on screen 1//
}

void loop() {
  AxisYv = analogRead(AxisY); //read Y axis//
  AxisXv = analogRead(AxisX); //read x axis//
  
  if(AxisXv < 5){ //Add Page//
    PageVal++;
    delay(250); //delay between reads so it doesn't change through pages all at once//
  }
    if(AxisXv > 1005){ //Subtract Page//
    PageVal--;
    delay(250); //delay between reads so it doesn't change through pages all at once//
  }
    if(AxisYv < 5){ //go down a line//
    LineVal --;
    delay(250); //delay between reads so it doesn't change through lines all at once//
  }
    if(AxisYv > 1005){ //go up a line//
    LineVal ++;
    delay(250); //delay between reads so it doesn't change through lines all at once//
  }
  
  LineVal = constrain(LineVal, 0, 4); //Only 5 lines fit on screen//
  
  LineNum = map(LineVal, 0, 4, 12, 53); //appropriate values to make selector line up with text//
  
  LineNum = constrain(LineNum, 12, 55); //keeps from going over or under assigned lines//
  
  PageVal = constrain(PageVal, 0, 3); //only 3 pages for now
  
  switch (PageVal) {            //Different pages//
   case 0: LCD1(); break;
   case 1: LCD2(); break;
   case 2: LCD3(); break;
   case 3: DosingSettingsLCD(); break;
   default: LCD1();
  }
  ButtonState = digitalRead(Button1); //Read State of the button//
  
  if(PageVal == 2 && LineVal == 1 && ButtonState == 0){ //if the C/F button is pressed toggle the value//
    CF = !CF;
    delay(100);
  }
  if(PageVal == 1 && LineVal == 2 && ButtonState == 0){ //if the dosing pump settings button is pressed enter that menu//
    PageVal = 3;
  }
    if(PageVal == 3 && LineVal == 3 && ButtonState == 0){ //if the back button is pressed within the dosing pump settings menu//
    PageVal = 1;
    delay(100);
  }
}



